// This file is to show how a library package may provide JavaScript interop features
// wrapped in a .NET API

window.sjsAdaptor = {
    init: function (host, config) {
        console.log("Init");
        if (config.hostStyle) {
            var hostStyle = config.hostStyle;
            var styles = hostStyle.split(';');
            styles.forEach((styleStr) => {
                var style = styleStr.split(':');
                host.style[style[0]] = style[1];
            });
            delete config.hostStyle;
        }

        return new GC.Spread.Sheets.Workbook(host, config);
    },

    setValue: function (host, sheetIndex, row, col, value) {
        var spread = GC.Spread.Sheets.findControl(host);
        if (spread) {
            var sheet = spread.getSheet(sheetIndex);
            sheet.setValue(row, col, value);
        }
    },

    openExcel: function (host, inputFile) {
        var spread = GC.Spread.Sheets.findControl(host);
        if (spread) {
            var excelIO = new GC.Spread.Excel.IO();
            excelIO.open(inputFile.files[0], function (json) {
                spread.fromJSON(json);
            })
        }
    },

    doSomeAsyncProcess: function (host) {
        return new Promise(function (resolve, reject) {
            var spread = GC.Spread.Sheets.findControl(host);
            if (spread) {
                setTimeout(function () {
                    spread.clearSheets();
                    alert("In doSomeAsyncProcess:" + spread.getSheetCount());
                    resolve("OK");
                }, 2000);
            } else {
                reject("Error");
            }
        });
    },
    getSheets: function (host) {
        var spread = GC.Spread.Sheets.findControl(host);
        if (spread) {
            alert("In getSheets:"+spread.getSheetCount());
        }
    }

};